// var allModules = ["toolbar-portal", "toolbar-mail", "toolbar-calendar",
//                  "toolbar-contacts", "toolbar-tasks", "toolbar-infostore",
//                  "toolbar-messaging", "com.4psa.voipnow.callhistory"];

var allModules = ["toolbar-infostore"];

var ifrm = document.createElement("IFRAME"); 
ifrm.setAttribute("src", ""); 
ifrm.setAttribute("id", "agorumCoreExplorerIFrame"); 
ifrm.setAttribute("name", "agorumCoreExplorerIFrame"); 
ifrm.style.width = 1+"px"; 
ifrm.style.height = 1+"px"; 
ifrm.style.visibility = "hidden";
document.body.appendChild(ifrm); 
   
for (var i = 0; i < allModules.length; i++) {
    var view = ox.widgets.toolBar.viewControl.views[allModules[i]];
    if (view) view.add(createGlobalTab());
}

function openDesk4webFolder(objId, server, sessionId, userName) {
	window.open(server+"/roiwebui/roiwebui_module/executeAction.do?parameterIdentifier=parameter.PortalPage&nextAction=parameter.portalmenu.Files&p=folderId||"+objId+"&transferedWsSessionId="+sessionId);
}

function openDesk4webFile(objId, server, sessionId, userName) {
	window.open(server+"/roiwebui/roiwebui_module/executeAction.do?parameterIdentifier=parameter.PortalPage&nextAction=parameter.Info&p=objectIds||"+objId+"&transferedWsSessionId="+sessionId);
}

function openExplorerAc(objectId, user, baseUrl) {
	var orgUrl = "execute?p=action||open&p=user||" + user +
		"&p=callerId||RoiWebUI&p=redirectUrl||" + baseUrl +
		"&p=url||" + baseUrl + "/dynawebservices/call&p=docId||" + objectId +
		"&p=wsSessionId||" + objectId + "&p=File:ID:path||" + objectId +
		"&p=Name:ID:name||" + objectId + "&p=Folder:ID:path||" + objectId +
		"&noCache=" + new Date().getTime();

	var src = baseUrl + "/roiwebui/roiwebui_module/redirectClientExecute.do?userName=" + user +
		"&redirectUrl=" + escape(orgUrl);

	document.getElementById("agorumCoreExplorerIFrame").src=src;
	//window.open(src);
}


function getParametersFromUrl(url) {
        var spl = url.split("?");
        var url1 = spl[0];
        var url2 = spl[1];
        var server = url2.substring(url2.lastIndexOf("&downloadUrl=")+13);
        server = unescape(server);
        server = server.substring(0, server.lastIndexOf("/roiwebui/wsfiling"));
        var wsSessionId = "";
        var userName = "";

        spl = url2.split("&");
        for (var i=0;i<spl.length;i++) {
                if (spl[i].indexOf("wsSessionId=") != -1) {
                        wsSessionId = spl[i].substring(spl[i].indexOf("=")+1);
                }
                else if (spl[i].indexOf("userName=") != -1) {
                        userName = spl[i].substring(spl[i].indexOf("=")+1);
                }
        }

        var parameters = new Array();
        parameters[0] =  server;
        parameters[1] =  wsSessionId;
        parameters[2] =  userName;
        return parameters;
}

function createGlobalTab() {
    var section = new ox.gui.PanelMenuSection(_("agorum core"));

	//Button for Edit Document
    var openButton = new ox.gui.MenuItem({
        title: _("Dokument direkt bearbeiten"),
        icons: ["icons/24/edit.png", "icons/24/edit.png"],
        action: function() {
		var grid;

		if(gridInfoList && gridInfoList.collection) {
			grid = gridInfoList;
		} else {
			grid = gridInfoSplit;
	   	}

		OXCache.newRequest(null, "infostore", {objects:grid.getSelectedIDs(), columns:["filename"]}, null, function(data) {
			var parameters = getParametersFromUrl(data.objects[0].url);
			
			var docId = data.objects[0].id;
			docId = docId.substring(docId.lastIndexOf("/")+1);
			
			//openDesk4webFile(docId, parameters[0], parameters[1], parameters[2]);
			openExplorerAc(docId, parameters[2], parameters[0]);

		});
        }
    });
    section.add(openButton);

	//Button for open explorer
    var openFileManager = new ox.gui.MenuItem({
        title: _("Ordner im Dateimanager oeffnen"),
        icons: ["icons/24/mod_foldertree.png", "icons/24/mod_foldertree.png"],
        action: function() {
		var grid;

		if(gridInfoList && gridInfoList.collection) {
			grid = gridInfoList;
		} else {
			grid = gridInfoSplit;
	   	}

		OXCache.newRequest(null, "infostore", {objects:grid.getSelectedIDs(), columns:["filename"]}, null, function(data) {
			var parameters = getParametersFromUrl(data.objects[0].url);
			
			var docId = data.objects[0].id;
			docId = docId.substring(0, docId.lastIndexOf("/"));
			docId = docId.substring(docId.lastIndexOf("/")+1);
			
			openExplorerAc(docId, parameters[2], parameters[0]);

		});
        }
    });
    section.add(openFileManager);
    
	//Button for Object-Info (File)
    var docInfo = new ox.gui.MenuItem({
        title: _("Dokumenten-Info"),
        icons: ["icons/24/list_view.png", "icons/24/list_view.png"],
        action: function() {
		var grid;

		if(gridInfoList && gridInfoList.collection) {
			grid = gridInfoList;
		} else {
			grid = gridInfoSplit;
	   	}

		OXCache.newRequest(null, "infostore", {objects:grid.getSelectedIDs(), columns:["filename"]}, null, function(data) {
			var parameters = getParametersFromUrl(data.objects[0].url);
			
			var docId = data.objects[0].id;
			docId = docId.substring(docId.lastIndexOf("/")+1);
			
			openDesk4webFile(docId, parameters[0], parameters[1], parameters[2]);
		});
        }
    });
    section.add(docInfo);	
	

	//Button for Open folder in desk4web
    var d4wFolder = new ox.gui.MenuItem({
        title: _("Ordner in desk4web oeffnen"),
        icons: ["icons/24/mod_infostore.png", "icons/24/mod_infostore.png"],
        action: function() {
		var grid;

		if(gridInfoList && gridInfoList.collection) {
			grid = gridInfoList;
		} else {
			grid = gridInfoSplit;
	   	}

		OXCache.newRequest(null, "infostore", {objects:grid.getSelectedIDs(), columns:["filename"]}, null, function(data) {
			var parameters = getParametersFromUrl(data.objects[0].url);
			
			var docId = data.objects[0].id;
			docId = docId.substring(0, docId.lastIndexOf("/"));
			docId = docId.substring(docId.lastIndexOf("/")+1);
			
			openDesk4webFolder(docId, parameters[0], parameters[1], parameters[2]);
		});
        }
    });
    section.add(d4wFolder);	
		
    var tab = new ox.gui.PanelMenu("", _("agorum core"));
    tab.add(section);
    return tab;
}
